<?php  defined('C5_EXECUTE') or die("Access Denied.");

class UsergroupExpiryBlockController extends BlockController {
	
	protected $btName = 'User Group Expiry Display';
	protected $btDescription = 'A block that reports how much time left before they are removed from a particular user group';
	protected $btTable = 'btUsergroupExpiry';
	
	protected $btInterfaceWidth = "350";
	protected $btInterfaceHeight = "250";
	
	protected $btCacheBlockRecord = true;
	protected $btCacheBlockOutput = true;
	protected $btCacheBlockOutputOnPost = true;
	protected $btCacheBlockOutputForRegisteredUsers = false;
	protected $btCacheBlockOutputLifetime = CACHE_LIFETIME;
	
	public function view() {
		$this->set('gID',$this->gID);
		
		$u = new User();
		$g = Group::getByID($this->gID);
		
		$expired = true;
		$ingroup = $u->inGroup($g);
		
		
		if ($ingroup && $g->isGroupExpirationEnabled()) {
			$db= Loader::db();
			$query = 'select ugEntered from UserGroups where uID = ? and gID =?';
			$result = $db->Execute($query ,array($u->getUserID(), $this->gID));
			$data = $result->FetchRow();
			
			$type = $g->getGroupExpirationMethod();
			
			if ($type == 'INTERVAL') {
				$days = $g->getGroupExpirationIntervalDays();
				$hours = $g->getGroupExpirationIntervalHours();
				$minutes = $g->getGroupExpirationIntervalMinutes();
				$seconds = ($minutes * 60) + ($hours * 3600) + ($days * 86400);
			} else {
				
			}
			
			$dateentered = strtotime($data['ugEntered']);
			$date = Loader::helper('date');
		
			$timeaway = time() - ($dateentered + $seconds);
			
			$expired = false;
			
			if ($timeaway >= 0){
				$timeaway = 0;
				$expired = true;
			}
			
			// this uses the date helpers's timeSince function in a cheeky way
			// If the time left is less than a day, it turns on the more specific time reporting
			$timeRemaining = $date->timeSince(time() + $timeaway);
			
			$this->set('timeRemaining', $timeRemaining);
		}	
		
		$this->set('groupName', $g->getGroupName());
		$this->set('inGroup', $ingroup);
		$this->set('expired', $expired);
		
	}
	
	public function add(){
		Loader::model('search/group');
		$ga = new GroupSearch();
		$ga->setItemsPerPage(1000);
		$groups = $ga->getPage();
		
		$grouplist = array();
		foreach($groups as $group) {
			$grouplist[$group['gID']] = $group['gName'];
		}
		$this->set('gID',$this->gID);
		$this->set('groups', $grouplist);
	}


	public function edit() {
		$this->add();
	}

	public function save($args) {
		
		parent::save($args);
	}


}
